package uml.step0;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.util.List;

import javax.swing.*;

/**
 * <p>^Cg: </p>
 * <p>: </p>
 * <p>쌠: Copyright (c) 2003</p>
 * <p>Ж: ʍH[</p>
 * @author 
 * @version 1.0
 */

public class Canvas extends JFrame {
  private JPanel panel;

  // -- constructor
  public Canvas(String title, Dimension d) {
    this.init();
    this.initFrame(title, d);
  }

  // -- initialize
  private void init() {
    this.panel = new JPanel();
  }

  // -- initialize
  private void initFrame(String title, Dimension d) {
    this.setTitle(title);
    this.setSize(d);

    this.panel.setLayout(new BorderLayout());
    this.getContentPane().add(panel);

    this.enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    this.setVisible(true);
  }

  // -- public class JFrame
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }

  // -- private accessing
  private Graphics graphics() {
    return this.getGraphics();
//    return this.panel.getGraphics();
  }

  // -- displaying
  public void displayCircle(Circle c) {
    int r = c.radius();
    int x      = c.x() - r;
    int y      = c.y() - r;
    int width  = r * 2;
    int height = r * 2;

    Graphics g = this.graphics();
    g.drawOval(x, y, width, height);
  }

  // -- displaying
  public void displayRectangle(Rectangle r) {
    int x      = r.x();
    int y      = r.y();
    int width  = r.width();
    int height = r.height();

    Graphics g = this.graphics();
    g.drawRect(x, y, width, height);
  }

  // -- examples
  public static void main(String[] args) {
    ex1();
  }

  private static void ex1() {
    Canvas canvas = new Canvas(
        "Ex: Graphics",
        new Dimension(200, 200));

    List list = new Vector();
    list.add(new Circle(new Point(100, 100), 50));
    list.add(new Rectangle(new Point(50, 50), new Point(100, 100)));

    Iterator iter = list.iterator();
    while (iter.hasNext()) {
      Object item = iter.next();
      if (item instanceof Circle) {
        canvas.displayCircle((Circle) item);
      }
      if (item instanceof Rectangle) {
        canvas.displayRectangle((Rectangle) item);
      }
    }
  }
}