package uml.step4;

import java.awt.*;

/**
 * <p>^Cg: </p>
 * <p>: </p>
 * <p>쌠: Copyright (c) 2003</p>
 * <p>Ж: ʍH[</p>
 * @author 
 * @version 1.0
 */

public class Rectangle extends Geometry {
  private Point origin;
  private Point corner;

  // -- constructor
  public Rectangle() {
  }

  // -- constructor
  public Rectangle(Point origin, Point corner) {
    this.origin = origin;
    this.corner = corner;
  }

  // -- accessing
  protected String classField() {
    return this.origin + "," + this.corner;
  }

  // -- public interface Shape
  public void display(Graphics g) {
    super.display(g);

    int x      = this.x();
    int y      = this.y();
    int width  = this.width();
    int height = this.height();

    g.setColor(this.fillColor);
    g.fillRect(x, y, width, height);
    g.setColor(this.drawColor);
    g.drawRect(x, y, width, height);
  }

  // -- accessing
  public int x() {
    return this.origin.x();
  }

  public int y() {
    return this.origin.y();
  }

  public int width() {
    return this.corner.x() - this.x();
  }

  public int height() {
    return this.corner.y() - this.y();
  }

  // -- examples
  public static void main(String[] args) {
    ex1();
  }

  private static void ex1() {
    Canvas canvas = new Canvas(
        "Ex: Rectangle",
        new Dimension(200, 200));
    Graphics g = canvas.graphics();

    Rectangle r = new Rectangle(new Point(30, 40), new Point(150, 120));
    r.setDrawColor(Color.blue);
    r.setFillColor(Color.white);
    System.out.println(r);

    r.display(g);
  }
}