package uml.step5;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.util.List;

import javax.swing.*;

/**
 * <p>^Cg: </p>
 * <p>: </p>
 * <p>쌠: Copyright (c) 2003</p>
 * <p>Ж: ʍH[</p>
 * @author 
 * @version 1.0
 */

public class Canvas extends JFrame {
  private JPanel panel;
  private Container container;

  // -- constructor
  public Canvas(String title, Dimension d) {
    this.init();
    this.initFrame(title, d);
  }

  // -- initialize
  private void init() {
    this.panel = new JPanel();
    this.container = new Container();
  }

  // -- initialize
  private void initFrame(String title, Dimension d) {
    this.setTitle(title);
    this.setSize(d);

    this.panel.setLayout(new BorderLayout());
    this.getContentPane().add(panel);

    this.enableEvents(AWTEvent.WINDOW_EVENT_MASK);
  }

  // -- public class JFrame
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }

  private Graphics graphics() {
    return this.panel.getGraphics();
  }

  public void add(Shape shape) {
    this.container.add(shape);
  }

  // -- public abstract class Component
  public void paint(Graphics g) {
    this.container.display(this.graphics());
  }

  // -- examples
  public static void main(String[] args) {
    ex1();
  }

  private static void ex1() {
    Canvas canvas = new Canvas(
        "Ex: Graphics",
        new Dimension(200, 200));

    Circle c = new Circle(new Point(100, 100), 50);
    c.setDrawColor(Color.red);
    c.setFillColor(Color.white);
    canvas.add(c);

    Rectangle r = new Rectangle(new Point(50, 50), new Point(100, 100));
    r.setDrawColor(Color.blue);
    r.setFillColor(Color.white);
    canvas.add(r);

    canvas.setVisible(true);
  }
}