package uml.step6;

import java.awt.*;

/**
 * <p>^Cg: </p>
 * <p>: </p>
 * <p>쌠: Copyright (c) 2003</p>
 * <p>Ж: ʍH[</p>
 * @author 
 * @version 1.0
 */

public class Circle extends Geometry {
  private Point center;
  private int radius;

  // -- constructor
  public Circle() {
  }

  // -- constructor
  public Circle(Point center, int radius) {
    this.center = center;
    this.radius = radius;
  }

  // -- private accessing
  protected String classField() {
    return this.center + "," + this.radius;
  }

  // -- public interface Shape
  public void display(Graphics g) {
    super.display(g);

    int r = this.radius();
    int x = this.x() - r;
    int y = this.y() - r;
    int width = r * 2;
    int height = r * 2;

    g.setColor(this.fillColor);
    g.fillOval(x, y, width, height);
    g.setColor(this.drawColor);
    g.drawOval(x, y, width, height);
  }

  // -- accessing
  public void translate(Point p) {
    this.center = this.center.translatedBy(p);
  }

  // -- accessing
  public int radius() {
    return this.radius;
  }

  // -- accessing
  public int x() {
    return this.center.x();
  }

  // -- accessing
  public int y() {
    return this.center.y();
  }

  // -- examples
  public static void main(String[] args) {
    ex1();
  }

  private static void ex1() {
    Canvas canvas = new Canvas(
        "Ex: Circle",
        new Dimension(200, 200));

    Point center = new Point(100, 80);
    int radius = 50;

    Circle c1 = new Circle(center, radius);
    c1.setDrawColor(Color.blue);
    c1.setFillColor(Color.white);
    canvas.add(c1);
    System.out.println(c1);

    Circle c2 = new Circle(center, radius);
    c2.setDrawColor(Color.red);
    c2.setFillColor(Color.white);
    canvas.add(c2);
    System.out.println(c2);

    c2.translate(new Point(20, 10));
    System.out.println(c2);

    canvas.setVisible(true);
  }
}