package uml.step6;

import java.awt.*;

/**
 * <p>^Cg: </p>
 * <p>: </p>
 * <p>쌠: Copyright (c) 2003</p>
 * <p>Ж: ʍH[</p>
 * @author 
 * @version 1.0
 */

public class Rectangle extends Geometry {
  private Point origin;
  private Point corner;

  // -- constructor
  public Rectangle() {
  }

  // -- constructor
  public Rectangle(Point origin, Point corner) {
    this.origin = origin;
    this.corner = corner;
  }

  protected String classField() {
    return this.origin + "," + this.corner;
  }

  // -- public interface Shape
  public void display(Graphics g) {
    super.display(g);

    int x      = this.x();
    int y      = this.y();
    int width  = this.width();
    int height = this.height();

    g.setColor(this.fillColor);
    g.fillRect(x, y, width, height);
    g.setColor(this.drawColor);
    g.drawRect(x, y, width, height);
  }

  public void translate(Point p) {
    this.origin = this.origin.translatedBy(p);
    this.corner = this.corner.translatedBy(p);
  }

  // -- accessing
  public int x() {
    return this.origin.x();
  }

  public int y() {
    return this.origin.y();
  }

  public int width() {
    return this.corner.x() - this.x();
  }

  public int height() {
    return this.corner.y() - this.y();
  }

  // -- examples
  public static void main(String[] args) {
    ex1();
  }

  private static void ex1() {
    Canvas canvas = new Canvas(
        "Ex: Rectangle",
        new Dimension(200, 200));

    Point origin = new Point( 30,  40);
    Point corner = new Point(150, 120);

    Rectangle r1 = new Rectangle(origin, corner);
    r1.setDrawColor(Color.blue);
    r1.setFillColor(Color.white);
    canvas.add(r1);
    System.out.println(r1);

    Rectangle r2 = new Rectangle(origin, corner);
    r2.setDrawColor(Color.red);
    r2.setFillColor(Color.white);
    canvas.add(r2);
    System.out.println(r2);

    r2.translate(new Point(20, 10));
    System.out.println(r2);

    canvas.setVisible(true);
  }
}