package uml.step7;

import java.awt.*;

/**
 * <p>^Cg: </p>
 * <p>: </p>
 * <p>쌠: Copyright (c) 2003</p>
 * <p>Ж: ʍH[</p>
 * @author 
 * @version 1.0
 */

public class Circle extends Geometry {
  private Point center;
  private int radius;

  // -- constructor
  public Circle(Point center, int radius) {
    this.center = center;
    this.radius = radius;
  }

  // -- private accessing
  protected String classField() {
    return this.center + "," + this.radius;
  }

  // -- public interface Shape
  public void display(Graphics g) {
    super.display(g);

    int r = this.radius();
    int x = this.x() - r;
    int y = this.y() - r;
    int width = r * 2;
    int height = r * 2;

    this.displayFilling(g, x, y, width, height);
    this.displayDrawing(g, x, y, width, height);
  }

  private void displayFilling(
      Graphics g, int x, int y, int width, int height) {

    if (this.fillColor == null) return;
    super.displayFilling(g);
    g.fillOval(x, y, width, height);
  }

  protected void displayDrawing(
      Graphics g, int x, int y, int width, int height) {

    super.displayDrawing(g);
    g.drawOval(x, y, width, height);
  }

  // -- accessing
  protected void translateFromWrapper(Point p) {
    this.center = this.center.translatedBy(p);
  }

  // -- accessing
  public int radius() {
    return this.radius;
  }

  // -- accessing
  public int x() {
    return this.center.x();
  }

  // -- accessing
  public int y() {
    return this.center.y();
  }

  // -- examples
  public static void main(String[] args) {
    ex1();
  }

  private static void ex1() {
    Canvas canvas = new Canvas(
        "Ex: Circle",
        new Dimension(420, 200));

    int radius = 30;

    Geometry g1 = new Circle(new Point(50, 50), radius);
    g1.setDrawColor(Color.cyan);
    g1.setFillColor(Color.white);
    g1.translate(new Point(0, 80));
    canvas.add(g1);
    System.out.println(g1);

    Geometry g2 = new Circle(new Point(130, 50), radius);
    Shape s2 = new TransformWrapper(g2);
    s2.setDrawColor(Color.magenta);
    s2.setFillColor(Color.white);
    s2.translate(new Point(0, 80));
    canvas.add(s2);
    System.out.println(s2);

    Geometry g3 = new Circle(new Point(210, 50), radius);
    Shape s3 = new DisplayWrapper(g3);
    s3.setDrawColor(Color.red);
    s3.setFillColor(Color.white);
    s3.translate(new Point(0, 80));
    canvas.add(s3);
    System.out.println(s3);

    Geometry g4 = new Circle(new Point(290, 50), radius);
    Shape s4 = new DisplayWrapper(new TransformWrapper(g4));
    s4.setDrawColor(Color.green);
    s4.setFillColor(Color.white);
    s4.translate(new Point(0, 80));
    canvas.add(s4);
    System.out.println(s4);

    Geometry g5 = new Circle(new Point(370, 50), radius);
    Shape s5 = new TransformWrapper(new DisplayWrapper(g5));
    s5.setDrawColor(Color.blue);
    s5.setFillColor(Color.white);
    s5.translate(new Point(0, 80));
    canvas.add(s5);
    System.out.println(s5);

    canvas.setVisible(true);
  }
}