package uml.step7;

import java.awt.*;

/**
 * <p>^Cg: </p>
 * <p>: </p>
 * <p>쌠: Copyright (c) 2003</p>
 * <p>Ж: ʍH[</p>
 * @author 
 * @version 1.0
 */

public class Rectangle extends Geometry {
  private Point origin;
  private Point corner;

  // -- constructor
  public Rectangle(Point origin, Point corner) {
    this.origin = origin;
    this.corner = corner;
  }

  // -- private accessing
  protected String classField() {
    return this.origin + "," + this.corner;
  }

  // -- public interface Shape
  public void display(Graphics g) {
    super.display(g);

    int x      = this.x();
    int y      = this.y();
    int width  = this.width();
    int height = this.height();

    this.displayFilling(g, x, y, width, height);
    this.displayDrawing(g, x, y, width, height);
  }

  private void displayFilling(
      Graphics g, int x, int y, int width, int height) {

    if (this.fillColor == null) return;
    super.displayFilling(g);
    g.fillRect(x, y, width, height);
  }

  protected void displayDrawing(
      Graphics g, int x, int y, int width, int height) {

    super.displayDrawing(g);
    g.drawRect(x, y, width, height);
  }

  // -- accessing
  protected void translateFromWrapper(Point p) {
    this.origin = this.origin.translatedBy(p);
    this.corner = this.corner.translatedBy(p);
  }

  // -- accessing
  public int x() {
    return this.origin.x();
  }

  public int y() {
    return this.origin.y();
  }

  public int width() {
    return this.corner.x() - this.x();
  }

  public int height() {
    return this.corner.y() - this.y();
  }

  // -- examples
  public static void main(String[] args) {
    ex1();
  }

  private static void ex1() {
    Canvas canvas = new Canvas(
        "Ex: Rectangle",
        new Dimension(420, 200));

    int radius = 30;

    Geometry g1 = new Rectangle(new Point(20, 20), new Point(80, 80));
    g1.setDrawColor(Color.cyan);
    g1.setFillColor(Color.white);
    g1.translate(new Point(0, 80));
    canvas.add(g1);
    System.out.println(g1);

    Geometry g2 = new Rectangle(new Point(100, 20), new Point(160, 80));
    Shape s2 = new TransformWrapper(g2);
    s2.setDrawColor(Color.magenta);
    s2.setFillColor(Color.white);
    s2.translate(new Point(0, 80));
    canvas.add(s2);
    System.out.println(s2);

    Geometry g3 = new Rectangle(new Point(180, 20), new Point(240, 80));
    Shape s3 = new DisplayWrapper(g3);
    s3.setDrawColor(Color.red);
    s3.setFillColor(Color.white);
    s3.translate(new Point(0, 80));
    canvas.add(s3);
    System.out.println(s3);

    Geometry g4 = new Rectangle(new Point(260, 20), new Point(320, 80));
    Shape s4 = new DisplayWrapper(new TransformWrapper(g4));
    s4.setDrawColor(Color.green);
    s4.setFillColor(Color.white);
    s4.translate(new Point(0, 80));
    canvas.add(s4);
    System.out.println(s4);

    Geometry g5 = new Rectangle(new Point(340, 20), new Point(400, 80));
    Shape s5 = new TransformWrapper(new DisplayWrapper(g5));
    s5.setDrawColor(Color.blue);
    s5.setFillColor(Color.white);
    s5.translate(new Point(0, 80));
    canvas.add(s5);
    System.out.println(s5);

    canvas.setVisible(true);
  }
}